<script>
import DataTable from '@/mixins/data-table'
import LocalStorage from '@/mixins/local-storage'
import getDataManifest from '@/assets/get-data-manifest'

export default {
  name: 'EventsPage',

  mixins: [DataTable, LocalStorage],

  async asyncData() {
    return { dataManifest: await getDataManifest() }
  },

  data() {
    return {
      fetchedData: [],
      rows: [],
      namespace: 'snowplow',
      paginationLimit: 15,
      columns: [
        {
          key: 'key',
          label: 'Key',
          sortable: true,
          thStyle: { width: '300px' },
        },
        { key: 'action', label: 'Action', sortable: true },
        { key: 'category', label: 'Category', sortable: true },
        { key: 'product_group', label: 'Group', sortable: true },
        { key: 'tiers', label: 'Tiers', sortable: true },
        { key: 'milestone', label: 'Milestone', sortable: true },
        {
          key: 'product_categories',
          label: 'Product Categories',
          sortable: false,
        },
      ],
      dataUrl: '',
      sharePath: '',
    }
  },

  head() {
    return {
      title: 'Events',
    }
  },

  created() {
    this.dataUrl = new URL(
      `data/snowplow.${this.dataManifest.snowplow}.json`,
      location.origin,
    ).toString()
    this.fetchData()
  },

  methods: {
    wrapCellWithMono(cell) {
      if (typeof cell !== 'string') {
        return cell
      }
      const hasWhiteSpace = /\s/.test(cell)

      if (hasWhiteSpace) {
        return this.$gridjs.html(`<em>${cell}</em>`)
      }

      return this.$gridjs.html(`<div class="font-mono">${cell}</div>`)
    },
  },
}
</script>

<template>
  <div class="px-4 sm:px-6 lg:px-8">
    <md-table-config
      :columns="columns"
      :rows="fetchedData"
      :namespace="namespace"
      :pagination-limit="paginationLimit"
      :share-path="sharePath"
      export-path="/data/snowplow.csv"
      context="event"
      :submit-search="submitSearch"
      :clear-search="clearSearch"
      @search="handleSearch"
      @columns-change="handleColumnsChange"
      @pagination-limit-change="handlePaginationLimitChange"
    />

    <md-table
      ref="table"
      :rows="rows"
      context="event"
      :columns="columns"
      :data-url="dataUrl"
      :pagination-limit="paginationLimit"
      @loaded-rows="buildSharePath"
    />
  </div>
</template>
